org.apache.lucene.index

## Class BaseNormsFormatTestCase

- java.lang.Object
- - org.junit.Assert
  - - org.apache.lucene.util.LuceneTestCase
    - - org.apache.lucene.index.BaseNormsFormatTestCase

-     public abstract class BaseNormsFormatTestCase
      extends LuceneTestCase

  Abstract class to do basic tests for a norms format. NOTE: This test focuses on the norms impl, nothing else. The [stretch] goal is for this test to be so thorough in testing a new NormsFormat that if this test passes, then all Lucene/Solr tests should also pass. Ie, if there is some bug in a given NormsFormat that this test fails to catch then this test needs to be improved!

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.apache.lucene.util.LuceneTestCase

      `LuceneTestCase.AwaitsFix, LuceneTestCase.BadApple, LuceneTestCase.Monster, LuceneTestCase.Nightly, LuceneTestCase.Slow, LuceneTestCase.SuppressCodecs, LuceneTestCase.SuppressFileSystems, LuceneTestCase.SuppressFsync, LuceneTestCase.SuppressReproduceLine, LuceneTestCase.SuppressSysoutChecks, LuceneTestCase.SuppressTempFileChecks, LuceneTestCase.ThrowingRunnable, LuceneTestCase.Weekly`

  - ### Field Summary

    - ### Fields inherited from class org.apache.lucene.util.LuceneTestCase

      `assertsAreEnabled, classRules, DEFAULT_LINE_DOCS_FILE, INFOSTREAM, JENKINS_LARGE_LINE_DOCS_FILE, LEAVE_TEMPORARY, MAYBE_CACHE_POLICY, RANDOM_MULTIPLIER, ruleChain, suiteFailureMarker, SYSPROP_AWAITSFIX, SYSPROP_BADAPPLES, SYSPROP_FAILFAST, SYSPROP_MAXFAILURES, SYSPROP_MONSTER, SYSPROP_NIGHTLY, SYSPROP_SLOW, SYSPROP_WEEKLY, TEST_ASSERTS_ENABLED, TEST_AWAITSFIX, TEST_BADAPPLES, TEST_CODEC, TEST_DIRECTORY, TEST_DOCVALUESFORMAT, TEST_LINE_DOCS_FILE, TEST_MONSTER, TEST_NIGHTLY, TEST_POSTINGSFORMAT, TEST_SLOW, TEST_THROTTLING, TEST_WEEKLY, VERBOSE`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `BaseNormsFormatTestCase()`

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected void` | `addRandomFields(Document doc)` Add random fields to the provided document.
    `protected <D extends Directory> D` | `applyCreatedVersionMajor(D d)` Set the created version of the given `Directory` and return it.
    `protected boolean` | `codecSupportsSparsity()` Whether the codec supports sparse values.
    `protected Collection<String>` | `excludedExtensionsFromByteCounts()` Return the list of extensions that should be excluded from byte counts when comparing indices that store the same content.
    `protected abstract Codec` | `getCodec()` Returns the codec to run tests against
    `protected int` | `getCreatedVersionMajor()` Returns the major version that this codec is compatible with.
    `protected boolean` | `mergeIsStable()`
    `void` | `setUp()` For subclasses to override.
    `void` | `tearDown()` For subclasses to override.
    `void` | `testAllZeros()`
    `void` | `testByteRange()`
    `void` | `testFewLargeValues()`
    `void` | `testFewSparseLargeValues()`
    `void` | `testFewSparseValues()`
    `void` | `testFewValues()`
    `void` | `testFullLongRange()`
    `void` | `testLongRange()`
    `void` | `testMergeStability()` The purpose of this test is to make sure that bulk merge doesn't accumulate useless data over runs.
    `void` | `testMostZeros()`
    `void` | `testMultiClose()` Calls close multiple times on closeable codec apis
    `void` | `testNCommon()`
    `void` | `testNCommonBig()` a more thorough n-common that tests all low bpv
    `void` | `testOutliers()`
    `void` | `testOutliers2()`
    `void` | `testRamBytesUsed()` Test the accuracy of the ramBytesUsed estimations.
    `void` | `testRandomExceptions()` Tests exception handling on write and openInput/createOutput
    `void` | `testShortRange()`
    `void` | `testSparseAllZeros()`
    `void` | `testSparseByteRange()`
    `void` | `testSparseFullLongRange()`
    `void` | `testSparseLongRange()`
    `void` | `testSparseNCommon()`
    `void` | `testSparseNCommonBig()` a more thorough n-common that tests all low bpv and sparse docs
    `void` | `testSparseOutliers()`
    `void` | `testSparseOutliers2()`
    `void` | `testSparseShortRange()`
    `void` | `testThreads()`
    `void` | `testUndeadNorms()`

    - ### Methods inherited from class org.apache.lucene.util.LuceneTestCase

      `addVirusChecker, assertDeletedDocsEquals, assertDocsAndPositionsEnumEquals, assertDocsEnumEquals, assertDocsSkippingEquals, assertDocValuesEquals, assertDocValuesEquals, assertFieldInfosEquals, assertFieldsEquals, assertFieldStatisticsEquals, assertNormsEquals, assertPointsEquals, assertPositionsSkippingEquals, assertReaderEquals, assertReaderStatisticsEquals, assertStoredFieldEquals, assertStoredFieldsEquals, assertTermsEnumEquals, assertTermsEquals, assertTermsStatisticsEquals, assertTermStatsEquals, assertTermVectorsEquals, asSet, assumeFalse, assumeNoException, assumeTrue, assumeWorkingMMapOnWindows, atLeast, atLeast, closeAfterSuite, closeAfterTest, collate, createTempDir, createTempDir, createTempFile, createTempFile, dumpArray, dumpIterator, expectThrows, expectThrows, getBaseTempDirForTestClass, getDataInputStream, getDataPath, getOnlyLeafReader, getTestClass, getTestName, hasWorkingMMapOnWindows, isTestThread, localeForLanguageTag, maybeChangeLiveIndexWriterConfig, maybeWrapReader, newAlcoholicMergePolicy, newAlcoholicMergePolicy, newDirectory, newDirectory, newDirectory, newDirectory, newDirectory, newField, newField, newFSDirectory, newFSDirectory, newIndexWriterConfig, newIndexWriterConfig, newIndexWriterConfig, newIOContext, newIOContext, newLogMergePolicy, newLogMergePolicy, newLogMergePolicy, newLogMergePolicy, newLogMergePolicy, newMaybeVirusCheckingDirectory, newMaybeVirusCheckingFSDirectory, newMergePolicy, newMergePolicy, newMockDirectory, newMockDirectory, newMockDirectory, newMockFSDirectory, newMockFSDirectory, newSearcher, newSearcher, newSearcher, newStringField, newStringField, newStringField, newStringField, newTextField, newTextField, newTieredMergePolicy, newTieredMergePolicy, overrideDefaultQueryCache, overrideTestDefaultQueryCache, random, randomLocale, randomTimeZone, rarely, rarely, replaceMaxFailureRule, resetDefaultQueryCache, restoreCPUCoreCount, restoreIndexWriterMaxDocs, restoreSpins, runWithRestrictedPermissions, setIndexWriterMaxDocs, setupCPUCoreCount, setupSpins, slowFileExists, usually, usually, wrapReader`

    - ### Methods inherited from class org.junit.Assert

      `assertArrayEquals, assertArrayEquals, assertArrayEquals, assertArrayEquals, assertArrayEquals, assertArrayEquals, assertArrayEquals, assertArrayEquals, assertArrayEquals, assertArrayEquals, assertArrayEquals, assertArrayEquals, assertArrayEquals, assertArrayEquals, assertArrayEquals, assertArrayEquals, assertEquals, assertEquals, assertEquals, assertEquals, assertEquals, assertEquals, assertEquals, assertEquals, assertEquals, assertEquals, assertFalse, assertFalse, assertNotNull, assertNotNull, assertNotSame, assertNotSame, assertNull, assertNull, assertSame, assertSame, assertThat, assertThat, assertTrue, assertTrue, fail, fail`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### BaseNormsFormatTestCase

          public BaseNormsFormatTestCase()

  - ### Method Detail

    - #### codecSupportsSparsity

          protected boolean codecSupportsSparsity()

      Whether the codec supports sparse values.

    - #### testByteRange

          public void testByteRange()
                             throws Exception

      Throws:
        `Exception`

    - #### testSparseByteRange

          public void testSparseByteRange()
                                   throws Exception

      Throws:
        `Exception`

    - #### testShortRange

          public void testShortRange()
                              throws Exception

      Throws:
        `Exception`

    - #### testSparseShortRange

          public void testSparseShortRange()
                                    throws Exception

      Throws:
        `Exception`

    - #### testLongRange

          public void testLongRange()
                             throws Exception

      Throws:
        `Exception`

    - #### testSparseLongRange

          public void testSparseLongRange()
                                   throws Exception

      Throws:
        `Exception`

    - #### testFullLongRange

          public void testFullLongRange()
                                 throws Exception

      Throws:
        `Exception`

    - #### testSparseFullLongRange

          public void testSparseFullLongRange()
                                       throws Exception

      Throws:
        `Exception`

    - #### testFewValues

          public void testFewValues()
                             throws Exception

      Throws:
        `Exception`

    - #### testFewSparseValues

          public void testFewSparseValues()
                                   throws Exception

      Throws:
        `Exception`

    - #### testFewLargeValues

          public void testFewLargeValues()
                                  throws Exception

      Throws:
        `Exception`

    - #### testFewSparseLargeValues

          public void testFewSparseLargeValues()
                                        throws Exception

      Throws:
        `Exception`

    - #### testAllZeros

          public void testAllZeros()
                            throws Exception

      Throws:
        `Exception`

    - #### testSparseAllZeros

          public void testSparseAllZeros()
                                  throws Exception

      Throws:
        `Exception`

    - #### testMostZeros

          public void testMostZeros()
                             throws Exception

      Throws:
        `Exception`

    - #### testOutliers

          public void testOutliers()
                            throws Exception

      Throws:
        `Exception`

    - #### testSparseOutliers

          public void testSparseOutliers()
                                  throws Exception

      Throws:
        `Exception`

    - #### testOutliers2

          public void testOutliers2()
                             throws Exception

      Throws:
        `Exception`

    - #### testSparseOutliers2

          public void testSparseOutliers2()
                                   throws Exception

      Throws:
        `Exception`

    - #### testNCommon

          public void testNCommon()
                           throws Exception

      Throws:
        `Exception`

    - #### testSparseNCommon

          public void testSparseNCommon()
                                 throws Exception

      Throws:
        `Exception`

    - #### testNCommonBig

          @LuceneTestCase.Nightly
          public void testNCommonBig()
                                                      throws Exception

      a more thorough n-common that tests all low bpv
      Throws:
        `Exception`

    - #### testSparseNCommonBig

          @LuceneTestCase.Nightly
          public void testSparseNCommonBig()
                                                            throws Exception

      a more thorough n-common that tests all low bpv and sparse docs
      Throws:
        `Exception`

    - #### addRandomFields

          protected void addRandomFields(Document doc)

      Add random fields to the provided document.

    - #### testMergeStability

          public void testMergeStability()
                                  throws Exception

      The purpose of this test is to make sure that bulk merge doesn't accumulate useless data over runs.
      Throws:
        `Exception`

    - #### testUndeadNorms

          public void testUndeadNorms()
                               throws Exception

      Throws:
        `Exception`

    - #### testThreads

          public void testThreads()
                           throws Exception

      Throws:
        `Exception`

    - #### getCodec

          protected abstract Codec getCodec()

      Returns the codec to run tests against

    - #### getCreatedVersionMajor

          protected int getCreatedVersionMajor()

      Returns the major version that this codec is compatible with.

    - #### applyCreatedVersionMajor

          protected final <D extends Directory> D applyCreatedVersionMajor(D d)
                                                                    throws IOException

      Set the created version of the given `Directory` and return it.
      Throws:
        `IOException`

    - #### setUp

          public void setUp()
                     throws Exception

      Description copied from class: `LuceneTestCase`
      For subclasses to override. Overrides must call `super.setUp()`.
      Overrides:
        `setUp` in class `LuceneTestCase`
      Throws:
        `Exception`

    - #### tearDown

          public void tearDown()
                        throws Exception

      Description copied from class: `LuceneTestCase`
      For subclasses to override. Overrides must call `super.tearDown()`.
      Overrides:
        `tearDown` in class `LuceneTestCase`
      Throws:
        `Exception`

    - #### excludedExtensionsFromByteCounts

          protected Collection<String> excludedExtensionsFromByteCounts()

      Return the list of extensions that should be excluded from byte counts when comparing indices that store the same content.

    - #### mergeIsStable

          protected boolean mergeIsStable()

    - #### testRamBytesUsed

          @LuceneTestCase.Slow
          public void testRamBytesUsed()
                                                     throws IOException

      Test the accuracy of the ramBytesUsed estimations.
      Throws:
        `IOException`

    - #### testMultiClose

          public void testMultiClose()
                              throws IOException

      Calls close multiple times on closeable codec apis
      Throws:
        `IOException`

    - #### testRandomExceptions

          public void testRandomExceptions()
                                    throws Exception

      Tests exception handling on write and openInput/createOutput
      Throws:
        `Exception`

Copyright © 2000-2018 Apache Software Foundation. All Rights Reserved.